/**
* This source code is an example that shows how to use the method i_PCI1032_Read32DigitalInputs
* The algorithm is the following:
* - Open board (via index or identifier - see the Utils.cpp file)
* - Call the method i_PCI1032_Read32DigitalInputs
* - Close the board
**/
#include "stdafx.h"

#define VALUE_CHANNEL(x,ch)	( (x >> ch) & 0x1 )

/**
* Entry point
**/
int _tmain( int /*argc*/, _TCHAR* /*argv[]*/ )
{
	INT returnValue = 0;
	HANDLE	boardHandle = NULL;
	DWORD channelsValue = 0;

	/* call the util method to open a board */
	returnValue = OpenBoard(&boardHandle);
	if (returnValue != 0)
	{
		printf("Error while opening the board : %d \n", (int) returnValue);
		_getch();
		return -1;
	}

	/* display some useful informations */
	printf("* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * \n");
	printf("* Read 32 digital inputs sample. \n");
	printf("* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * \n\n");

	do
	{
		system("cls");
		printf("\n Press any key to exit the sample ...\n");

		/* read the value of the selected channel */
		returnValue = i_PCI1032_Read32DigitalInputs(boardHandle, &channelsValue);
		if (returnValue != 0)
		{
			printf("i_PCI1032_Read32DigitalInputs error : %d \n", returnValue);
			/* close the board and return */
			i_PCI1032_CloseBoard(boardHandle);
			_getch();
			return -1;
		}

		/* print the channel value */
		printf("_________________________________________________________________\n");
		printf("|0  |1  |2  |3  |4  |5  |6  |7  |8  |9  |10 |11 |12 |13 |14 |15 |\n");
		printf("|%d  |%d  |%d  |%d  |%d  |%d  |%d  |%d  |%d  |%d  |%d  |%d  |%d  |%d  |%d  |%d  |\n",VALUE_CHANNEL(channelsValue,0),
			VALUE_CHANNEL(channelsValue,1),
			VALUE_CHANNEL(channelsValue,2),
			VALUE_CHANNEL(channelsValue,3),
			VALUE_CHANNEL(channelsValue,4),
			VALUE_CHANNEL(channelsValue,5),
			VALUE_CHANNEL(channelsValue,6),
			VALUE_CHANNEL(channelsValue,7),
			VALUE_CHANNEL(channelsValue,8),
			VALUE_CHANNEL(channelsValue,9),
			VALUE_CHANNEL(channelsValue,10),
			VALUE_CHANNEL(channelsValue,11),
			VALUE_CHANNEL(channelsValue,12),
			VALUE_CHANNEL(channelsValue,13),
			VALUE_CHANNEL(channelsValue,14),
			VALUE_CHANNEL(channelsValue,15));

		/* print the channel value */
		printf("\n_________________________________________________________________\n");
		printf("|16 |17 |18 |19 |20 |21 |22 |23 |24 |25 |26 |27 |28 |29 |30 |31 |\n");
		printf("|%d  |%d  |%d  |%d  |%d  |%d  |%d  |%d  |%d  |%d  |%d  |%d  |%d  |%d  |%d  |%d  |\n",VALUE_CHANNEL(channelsValue,16),
			VALUE_CHANNEL(channelsValue,17),
			VALUE_CHANNEL(channelsValue,18),
			VALUE_CHANNEL(channelsValue,19),
			VALUE_CHANNEL(channelsValue,20),
			VALUE_CHANNEL(channelsValue,21),
			VALUE_CHANNEL(channelsValue,22),
			VALUE_CHANNEL(channelsValue,23),
			VALUE_CHANNEL(channelsValue,24),
			VALUE_CHANNEL(channelsValue,25),
			VALUE_CHANNEL(channelsValue,26),
			VALUE_CHANNEL(channelsValue,27),
			VALUE_CHANNEL(channelsValue,28),
			VALUE_CHANNEL(channelsValue,29),
			VALUE_CHANNEL(channelsValue,30),
			VALUE_CHANNEL(channelsValue,31));
		
		/* show that something is running */
		DisplayRunningStatus();

		Sleep(100);
	}
	while ( !_kbhit() );

	/* close the board */
	returnValue = i_PCI1032_CloseBoard(boardHandle);
	if (returnValue != 0)
	{
		printf("Error while closing board : %d \n", (int)returnValue);
		_getch();
		return -1;
	}

	/* success */
	return 0;
}

