using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace PCI1032_NET
{
    /// <summary>
    /// Contains the call to the DLL functions
    /// </summary>
    public class DllImport
    {
        /// <summary>
        /// Definition of the function that must be given to use the interruption of the board
        /// </summary>
        /// <param name="handle"></param>
        /// <param name="fifoOverflow"></param>
        /// <param name="mask"></param>
        /// <param name="values"></param>
        [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
        public delegate void InterruptFunctionEventHandler(IntPtr handle,
                                                            byte fifoOverflow,
                                                            ushort interruptMask,
                                                            ushort inputStatus);

        [DllImport("PCI1032.dll")]
        public static extern short i_PCI1032_GetNumberOfBoards(ref byte nbBoard);

        [DllImport("PCI1032.dll")]
        public static extern short i_PCI1032_OpenBoardViaIndex(byte index, ref IntPtr deviceHandle);

        [DllImport("PCI1032.dll")]
        public static extern short i_PCI1032_CloseBoard(IntPtr deviceHandle);

        [DllImport("PCI1032.dll")]
        public static extern short i_PCI1032_SetBoardIntRoutine(IntPtr deviceHandle, [MarshalAs(UnmanagedType.FunctionPtr)] InterruptFunctionEventHandler interruptFunction);

        [DllImport("PCI1032.dll")]
        public static extern short i_PCI1032_ResetBoardIntRoutine(IntPtr deviceHandle);

        [DllImport("PCI1032.dll")]
        public static extern short i_PCI1032_Read1DigitalInput(IntPtr deviceHandle,byte channel, ref byte value);

        [DllImport("PCI1032.dll")]
        public static extern short i_PCI1032_Read8DigitalInputs(IntPtr deviceHandle, byte port, ref byte value);

        [DllImport("PCI1032.dll")]
        public static extern short i_PCI1032_Read16DigitalInputs(IntPtr deviceHandle, byte port, ref ushort value);

        [DllImport("PCI1032.dll")]
        public static extern short i_PCI1032_Read32DigitalInputs(IntPtr deviceHandle, ref uint value);

        [DllImport("PCI1032.dll")]
        public static extern short i_PCI1032_InitEventLogic(IntPtr deviceHandle, byte eventMode, string mask);

        [DllImport("PCI1032.dll")]
        public static extern short i_PCI1032_StartEventLogic(IntPtr deviceHandle);

        [DllImport("PCI1032.dll")]
        public static extern short i_PCI1032_StopEventLogic(IntPtr deviceHandle); 
    }
}
